/*-
 * Copyright (C)2005..2014 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#define Sa 0x00000001 /* (segment->index >= indx)                                */
#define Ss 0x00000002 /* (segment->index < idx->index)     */
#define Se 0x00000004 /* (segment->index == idx->index)       */
#define Si 0x00000008 /* (segmin <= indx)                                        */
#define Sr 0x00000010 /* (res)                                      */
#define Sx 0x00000020 /* (segi < SIZE(level))                    */
#define So 0x00000040 /* (indx <= idx->index)                                    */
#define S_full   0x3F

#define Cp 0x00800000 /*         */
#define Cr 0x00400000 /*   mular_get */
#define Cs 0x00200000 /*     */
#define Cd 0x00100000 /*  mular_dub           */
#define Cy 0x00080000 /*       */
#define Ci 0x00040000 /*           */
#define Ce 0x00020000 /*              */
#define C_state  0xFF /*            */

enum states {d0, de, dx};
/* d0 -   
   de -  
   dx - 
 */
/* AUTOCOPY END */

#define S 6
static const char Sconst[S] = "aseirx";
static const char pn[] = "        prsdyiex";
static const char *statenames[] = {"d0", "de", "dx"};

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2005..2014 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: table.c,v 1.8 2014/09/16 18:01:03 babolo Exp $";
#endif /* not lint */

#define BLIN_COMPAT  3
#define MIFE_COMPAT  4
#define MULAR_COMPAT 0

#include <sys/types.h>
#include <sys/event.h>
#include <sys/time.h>
#include <sysexits.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include <mife.h>
#include "../multilar.h"

struct {
    char      d[4];
    char      s[S + 1];
    char      f;
    u_int32_t c;
    int32_t   x;
} st[] =
/* d0e     aseirxo */
{ {"*  ", "     |", '+', Ci|Cp, d0}
, {"*  ", "|     ", '-',    Cp, -1}
, {"*  ", " |    ", '-',    Cp, -1}
, {"*  ", "  |   ", '-',    Cp, de}
, {"*  ", " --  |", '+',     0, de}
, {"*  ", "|  |-|", '+',    Cr, -1}
, {"*  ", "|   ||", '+',    Cs, -1}
, {"*  ", "    --", '+',    Cd, dx}
, {"*  ", "    |-", '+',    Cy, dx}
, {" * ", "    - ", '+',    Cd, dx}
, {" * ", "    | ", '+',    Cy, dx}
, {" * ", "      ", '+',     0, dx}
, {"** ", " ||   ", '-', Cp|Cr|Cs|Cd|Cy|Ci,dx}
, {"** ", " ||   ", '+',    Ce, dx}
, {"** ", " |   -", '-', Cp|Cr|Cs|Cd|Cy|Ci,dx}
, {"** ", " |   -", '+',    Ce, dx}
, {"** ", "  |  -", '-', Cp|Cr|Cs|Cd|Cy|Ci,dx}
, {"** ", "  |  -", '+',    Ce, dx}
, {   "",       "",'\0',     0,  0}
, {"** ", "      ", '+',     0,  0}
, {   "",       "",'\0',     0,  0}
};

int
main(int argc, char **argv) {
    u_int32_t automa[S_full + 1][dx];
    u_int32_t i, j, k, l, m;
    mife_descriptor *mf;
    char *src, *end;

    if  (!asprintf(&src, "%s.c", *argv)) err(EX_NOINPUT, "#1");
    if  (!(mf = mife_init(MIFE_FULL))) err(EX_NOINPUT, "#2");
    if  (mife_ctl(mf, MIFE_CTLFILE, src)) err(EX_NOINPUT, "#3");
    if  (!mife_ctl(mf, MIFE_CTLREAD, (off_t)0, (ssize_t)0)) err(EX_NOINPUT, "#4");
    if  (!(src = mife_point(mf, MIFE_POINTER))) err(EX_NOINPUT, "#5");
//  if  (!(src = strstr(src, "\n/* AUTOCOPY BEGIN */\n"))) err(EX_NOINPUT, "#6");
//  src += strlen("\n/* AUTOCOPY BEGIN */\n");
    if  (!(end = strstr(src, "\n/* AUTOCOPY END */\n"))) err(EX_NOINPUT, "#7");
    *(++end) = '\0';
    for (j = 0; j <= S_full; j++) {
        for (i = d0; i < dx; i++) {
            automa[j][i] = 0;
    }   }
    for (i = 0; st[i].d[0] && st[i].s[0]; i++) {
        for (j = 0, l = 0, m = 0; st[i].s[j]; j++) {
            switch(st[i].s[j]) {
            case '|':
            case '+':
                l |= 1 << j;
            case '-':
            case '=':
                m |= 1 << j;
        }   }
        for (j = d0; j < dx; j++) {
            for (k = 0; k <= S_full; k++) {
                if  ((st[i].d[j] != ' ') && ((k & m) == l)) {
                    if  (st[i].f == '+' || st[i].f == '|') automa[k][j] |= st[i].c;
                    if  (st[i].f == '-' || st[i].f == '=') automa[k][j] &= ~st[i].c;
                    if  (st[i].x != -1) {
                        automa[k][j] &= ~C_state;
                        automa[k][j] |= st[i].x;
    }   }   }   }   }
    printf("%s", src);
//  for (i = 0; st[i].d[0] && st[i].s[0]; i++) {
//      printf("%s %s %08X %02X\n", st[i].d, st[i].s, st[i].c, st[i].x & 0xFF);
//  }
    printf("static const u_int32_t automa[S_full + 1][dx] =\n"
"/*        d0        de */\n"
);
    for (j = 0; j <= S_full; j++) {
        printf("%s {", j ? "," : "{");
        for (i = d0; i < dx; i++) {
            printf("%s", i ? "," : "");
            for (k = 0, l = 0; pn[k] && (k < 24); k++) {
                if  ((0x80000000 >> k) & automa[j][i]) {
                    if  (!l && ((0x80000000 >> k) & (Ci|Cd|Cy))) {
                        printf("   C%c", pn[k]);
                        l++;
                    } else {
                        printf("%sC%c", l ? "|" : "", pn[k]);
                    }
                    l++;
            }   }
            for (; l < 2; l++) printf("   ");
//          printf("(%08X)", automa[j][i]);
            printf("| %s", statenames[automa[j][i] & C_state]);
        }
        printf("} /*");
        for (i = 0; i < S; i++) {
            printf("%c", (j & (1 << (S - i - 1))) ? Sconst[S - i - 1] : ' ');
        }
        printf("*/\n");
    }
    printf("};\n");
    exit(EX_OK);
}
